@import "../global/var";

.main-nav {
    &__container {
        height: calc(100vh - #{$header_height});
        display: flex;
        flex-direction: column;
        max-width: $sidebar_width;
        flex: 0 0 $sidebar_width;
        margin-top: $header_height;
        z-index: $z-index-sidebar;
        white-space: nowrap;
        background-color: $white;
        box-shadow: 0px 6px 10px rgba(0, 0, 0, 0.14), 0px 1px 18px rgba(0, 0, 0, 0.12), 0px 3px 5px rgba(0, 0, 0, 0.2);
        transform: translateZ(0);
        transition: max-width 0.1s linear;
        will-change: max-width;

        &._hidden {
            display: none !important;
        }

        .sidebar-menu-button {
            display: none;
        }

        &._expanded {
            max-width: $sidebar_width_expanded;
            flex: 0 0 $sidebar_width_expanded;
            transition: max-width 0.1s linear;
            will-change: max-width;
            transform: translateZ(0);

            .main-nav {
                &__list {
                    width: $sidebar_width_expanded;
                    transform: translate3d(0, 0, 0);
                }

                &__text {
                    opacity: 1;
                }
            }
        }
    }

    &__list {
        margin: 0;
        padding: 0;
        list-style-type: none;
        height: 100%;
        width: $sidebar_width;
        display: flex;
        flex-direction: column;
        transition: width 0.1s linear, transform 0.2s linear;
        transform: translate3d(0, 0, 0);

        &-item {
            height: 48px;

            &._empty {
                height: auto;

                &:hover {
                    cursor: default;
                }
            }

            &.active {
                .main-nav {
                    &__link {
                        background-color: $turquoise69a;

                        &.md-button {
                            &:not([disabled]),
                            &.md-focused:not(.md-icon-button),
                            &.md-focused:not(.md-icon-button):not([disabled]) {
                                background-color: $turquoise69a;
                            }
                            &[disabled] {
                                opacity: 0.7;
                                &:hover {
                                    background-color: $turquoise69a;

                                    & .material-icons {
                                        & svg {
                                            & path {
                                                color: $white;
                                                fill: $white;
                                            }
                                        }
                                    }
                                }
                            }
                        }

                        & .material-icons {
                            & svg {
                                & path {
                                    color: $white;
                                    fill: $white;
                                }
                            }
                        }
                    }

                    &__text {
                        color: $white;
                    }
                }
            }

            &:hover,
            &.active:hover {
                .main-nav {
                    &__link {
                        background-color: $brand-light-hover;

                        &.md-button {
                            &:not([disabled]),
                            &.md-focused:not(.md-icon-button),
                            &.md-focused:not(.md-icon-button):not([disabled]) {
                                background-color: $brand-light-hover;
                            }
                            &[disabled] {
                                opacity: 0.7;
                            }
                        }

                        & .material-icons {
                            & svg {
                                & path {
                                    color: $white;
                                    fill: $white;
                                }
                            }
                        }
                    }

                    &__text {
                        color: $white;
                    }
                }
            }

            &:hover {
                .main-nav {
                    &__link {
                        &.md-button {
                            &[disabled] {
                                background-color: transparent;

                                & .material-icons {
                                    & svg {
                                        & path {
                                            color: $gray57c;
                                            fill: $gray57c;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    &__link {
        height: 48px;
        max-height: none;
        width: 100%;
        min-width: auto;
        display: flex;
        align-items: center;
        padding: 0;
        border-radius: 0;
        transition: background-color 0.25s ease;

        &.md-button {
            &:not([disabled]),
            &.md-focused:not(.md-icon-button),
            &.md-focused:not(.md-icon-button):not([disabled]) {
                // ^^ to fix bug with default angular material styles
                height: 48px;
                width: 100%;
                padding: 0;
                min-width: auto;
                max-height: none;
                border-radius: 0;

                &:hover {
                    background-color: $brand-light-hover;

                    & .material-icons {
                        & svg {
                            & path {
                                color: $white;
                                fill: $white;
                            }
                        }
                    }
                }
            }

            &[disabled] {
                opacity: 0.7;
            }
        }

        & .material-icons {
            height: 20px;
            width: 20px;
            max-height: 20px;
            max-width: 20px;
            font-size: 20px;
            transition: color 0.25s ease;

            & svg {
                & path {
                    color: $gray57c;
                    fill: $gray57c;
                }
            }
        }
    }

    &__icon-wrapper {
        width: 50px;
        flex: 0 0 50px;
        display: flex;
        align-items: center;
        justify-content: center;
    }

    &__text {
        font-size: 14px;
        line-height: 24px;
        text-transform: uppercase;
        color: $gray57c;
        font-weight: 400;
        flex: 1 1 190px;
        text-align: left;
        opacity: 0;
        transition: opacity 0.25s linear;
    }

    &__button {
        height: 48px;
        width: 100%;
        display: flex;
        align-items: center;
        overflow: hidden;
        color: $gray8be;

        &-icon {
            user-select: none;

            &-wrapper {
                height: 48px;
                display: flex;
                align-items: center;
                justify-content: center;
                transform: rotate(0deg);
                flex: 0 0 48px;
            }

            &-wrapper._expanded & {
                transform: rotate(180deg);
            }
        }

        &-text {
            display: flex;
            align-items: center;
            flex: 1 1 auto;
            user-select: none;
        }
    }
}

@media (max-width: $md-screen-xs) {
    .main-nav {
        &__list {
            width: 0;
            opacity: 0;
        }

        &__container {
            z-index: $z-index-header + 1; //should be above the header
            position: fixed;
            width: 0;
            transition: width 0.1s linear;
            transition-delay: 0.1s;

            .sidebar-menu-button {
                position: absolute;
                display: block;
                height: $header_height;
                width: $sidebar_width;
                top: -40px;

                .menu-btn,
                .md-button {
                    min-height: $header_height;

                    &:not([disabled]),
                    &:not([disabled]):hover,
                    &.md-focused:not(.md-icon-button),
                    &.md-focused:not(.md-icon-button):not([disabled]) {
                        max-width: $sidebar_width;
                        min-width: auto;
                        max-height: $header_height;
                        padding: 0;
                        text-align: center;
                        color: $white;
                    }
                }
            }

            &.toggle-bottom {
                width: $sidebar_width;
                transition-delay: 0s;

                i {
                    &.nav-menu-icon {
                        display: none;
                    }
                    &.nav-close-icon {
                        display: block;
                        animation: rotateRight 0.09s linear forwards;
                    }
                }

                .main-nav {
                    &__list {
                        width: $sidebar_width;
                        opacity: 1;
                    }
                }
            }

            &:not(.toggle-bottom) {
                i.nav-close-icon {
                    display: none;
                }
            }
        }
    }
}

@keyframes rotateRight {
    from {
        transform: rotate(0);
    }
    to {
        transform: rotate(90deg);
    }
}
